<?php

namespace Siteguarding\Geoprot\Setup;

class InstallSchema implements \Magento\Framework\Setup\InstallSchemaInterface
{
    public function install(\Magento\Framework\Setup\SchemaSetupInterface $setup, \Magento\Framework\Setup\ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();


        if (!$installer->tableExists('siteguarding_geoprot_config')) {
            $table = $installer->getConnection()->newTable(
                $installer->getTable('siteguarding_geoprot_config')
            )
                ->addColumn(
                    'id',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'identity' => true,
                        'unsigned' => true,
                        'nullable' => false,
                        'primary' => true,
                    ],
                    'ID'
                )
                ->addColumn(
                    'var_name',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Var Name'
                )
                ->addColumn(
                    'var_value',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Var Value'
                )
                ->setComment('Geo protection Config Table');
            $installer->getConnection()->createTable($table);
        }

        if (!$installer->tableExists('siteguarding_geoprot_ip')) {
            $table = $installer->getConnection()->newTable(
                $installer->getTable('siteguarding_geoprot_ip')
            )
                ->addColumn(
                    'id',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'identity' => true,
                        'unsigned' => true,
                        'nullable' => false,
                        'primary' => true,
                    ],
                    'ID'
                )
                ->addColumn(
                    'ip_from',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'IP From'
                )
                ->addColumn(
                    'ip_till',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Ip Till'
                )
                ->addColumn(
                    'country_code',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Country Code'
                )
                ->setComment('Geo protection IP Table');
            $installer->getConnection()->createTable($table);
        }

        if (!$installer->tableExists('siteguarding_geoprot_stats')) {
            $table = $installer->getConnection()->newTable(
                $installer->getTable('siteguarding_geoprot_stats')
            )
                ->addColumn(
                    'id',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'identity' => true,
                        'unsigned' => true,
                        'nullable' => false,
                        'primary' => true,
                    ],
                    'ID'
                )
                ->addColumn(
                    'time',
                    \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Time'
                )
                ->addColumn(
                    'ip',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'IP'
                )
                ->addColumn(
                    'country_code',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false
                    ],
                    'Country Code'
                )
                ->addColumn(
                    'url',
                    \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    null,
                    [
                        'nullable' => false,
                    ],
                    'Country Code'
                )
                ->setComment('Geo protection Stats Table');
            $installer->getConnection()->createTable($table);
        }

        $installer->endSetup();
    }
}